
def checkpoints(wins, var1, var2):
    value1 = None
    for winname, ops in wins.iteritems():
        for op in ops:
            if op.instruction == 0x34:
                if op.a == var1:
                    value1 = op.b
                elif op.a == var2 and op.b:
                    yield value1, op.b, winname, op.address

if __name__ == '__main__':
    import sys
    import sogna.dat, sogna.win
    datpath = sys.argv[1]
    var1 = int(sys.argv[2])
    var2 = int(sys.argv[3])

    winnames = []
    wins = dict()
    strings = dict()
    with sogna.dat.DATArchive(datpath) as dat:
        for fn in dat.filenames():
            if fn.lower().endswith('.win'):
                winnames.append(fn)
                wins[fn] = sogna.win.bytecode.parse(dat.read(fn))

    for v1, v2, fn, addr in sorted(checkpoints(wins, var1, var2)):
        print v1, v2, fn, addr
#
